# Brittle Fish Read Me

Brittle Fish is a repository for testing and demonstrating the Console.Waterworks (Full & Core) NuGet packages. The main aim is to see how well they work in an F#-only environment.

Console.Waterworks is a NuGet package for creating MVC-like console programs. It allows you to define methods with parameters which the user can execute at runtime.
For more information about the Console.Waterworks projects, use the following links:

- [Console.Waterworks](https://git.abbether.net/craig.oates/Console.Waterworks)
- [Console.Waterworks.Core](https://git.abbether.net/craig.oates/Console.Waterworks.Core)

**Tip**: The main wiki is in the Console.Waterworks repository and I suggest you start [there](https://git.abbether.net/craig.oates/Console.Waterworks/wikis/home).

## Pre-Requisites

The repository was created using the following,

- .Net 4.7+
- .Net Core 2+
- Visual Studio 2017 (15.7.3)
- F# 4.1

## The Reason for this Repository

Both Console.Waterworks packages are written in C#. They were, also, written without F# (or V.B.) in mind. At the time, this was fine because I had no intention of learning either of the other two languages. One thing I was intent on doing, though, was using them in an everyday context for a few projects before I took C.W. out of alpha/beta. During this testing period, I somehow managed to pick up enough F# to do damage. I did not intend on it but my curiosity piqued and I thought "why not?". So, here we are...

## Where to Start with this Repository

If you are more of a *"show me the code"* type of person, clone the repository and dig-in. The Visual Studio solution is split into four projects. Two are for the full Dot Net framework an the other two are for Core. Regardless of which version you want to play with, I recommend you start in the console projects.

![Brittle Fish Solution Setup](brittle-fish-solution-setup.png)

If you are more of a *"where's the manual?"* type of person, I recommend you head over to the wiki.

- [Brittle Fish Wiki](https://git.abbether.net/craig.oates/Brittle-Fish/wiki)

## Contributing to the Repository

I do not intend for this to become an active repository. My main aim is for it to act as reference material for using Console.Waterworks in an F#-only environment. That being said, I am not against the odd crazy idea or two. If you manage to use Console.Waterworks in a useful and interesting way, let me know. I recommend filing an issue but you can email if you prefer.

- [Create a new issue](https://git.abbether.net/craig.oates/Brittle-Fish/issues)
- Email: [craig@craigoates.net](mailto:craig@craigoates.net)

I do not anticipate a lot of feedback so I have not made an issues template. I have, also, not made a coding standard either. So, please be kind when posting an issue or pull request.